package ru.myitschool.work.ui.profile

import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.paging.PagingDataAdapter
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.RecyclerView
import ru.myitschool.work.databinding.PassItemBinding
import ru.myitschool.work.domain.entities.PassEntity

class PassesListAdapter:
    PagingDataAdapter<PassEntity, PassesListAdapter.ViewHolder>(CenterDiff) {

    class ViewHolder(
        private val binding: PassItemBinding,
    ) : RecyclerView.ViewHolder(binding.root) {
        fun bind(item: PassEntity) {
            binding.time.text = item.time
            binding.name.text = item.name
            binding.type.text = item.type
        }
    }

    object CenterDiff : DiffUtil.ItemCallback<PassEntity>() {
        override fun areContentsTheSame(oldItem: PassEntity, newItem: PassEntity): Boolean {
            return oldItem.name == newItem.name
        }

        override fun areItemsTheSame(oldItem: PassEntity, newItem: PassEntity): Boolean {
            return oldItem == newItem
        }
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        return ViewHolder(
            PassItemBinding.inflate(LayoutInflater.from(parent.context), parent, false),
        )
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        holder.bind(
            getItem(position) ?: PassEntity(
                type = "Загрузка ...",
                name = "Терминал №...",
                time = "Давным-давно..."
            )
        )
    }

}